'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _utils = require('./utils');

var _FlexiGridUpdateHelper = require('./FlexiGridUpdateHelper');

var _FlexiGridCell = require('./FlexiGridCell');

var _FlexiGridCell2 = _interopRequireDefault(_FlexiGridCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NO_RIGHT_BORDR = 'no-right-border';

var FlexiGridCellGroup = function (_React$Component) {
  (0, _inherits3.default)(FlexiGridCellGroup, _React$Component);

  function FlexiGridCellGroup() {
    (0, _classCallCheck3.default)(this, FlexiGridCellGroup);
    return (0, _possibleConstructorReturn3.default)(this, (FlexiGridCellGroup.__proto__ || (0, _getPrototypeOf2.default)(FlexiGridCellGroup)).apply(this, arguments));
  }

  (0, _createClass3.default)(FlexiGridCellGroup, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.initialRender = true;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initialRender = false;
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return (0, _FlexiGridUpdateHelper.shouldUpdateCellGroup)(this.props, nextProps);
    }
  }, {
    key: 'renderBodyCells',
    value: function renderBodyCells() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          height = _props.height,
          leafColumns = _props.leafColumns,
          leafColumnsToRender = _props.leafColumnsToRender,
          record = _props.record,
          fixLastColumn = _props.fixLastColumn;


      var left = 0;

      return (leafColumnsToRender || leafColumns).map(function (column) {
        var width = column.width,
            key = column.key,
            dataIndex = column.dataIndex,
            render = column.render,
            rowIndex = column.rowIndex,
            offsetLeft = column.offsetLeft,
            isLastLeaf = column.isLastLeaf;

        var cellProps = {
          prefixCls: prefixCls,
          width: width,
          height: height,
          left: offsetLeft !== undefined ? offsetLeft : left,
          record: record,
          dataIndex: dataIndex,
          rowIndex: rowIndex,
          render: render
        };

        if (fixLastColumn && isLastLeaf) {
          cellProps.className = NO_RIGHT_BORDR;
        }

        left += width;
        return _react2.default.createElement(_FlexiGridCell2.default, (0, _extends3.default)({ key: key }, cellProps));
      });
    }
  }, {
    key: 'renderHeaderMergedCells',
    value: function renderHeaderMergedCells(height, left, column) {
      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          rowHeight = _props2.rowHeight,
          fixLastColumn = _props2.fixLastColumn;
      var children = column.children,
          width = column.width,
          title = column.title,
          align = column.align,
          isLastLeaf = column.isLastLeaf,
          key = column.key;

      var cellProps = {
        prefixCls: prefixCls,
        width: width,
        height: rowHeight,
        left: 0,
        align: align || 'center',
        render: title
      };

      if (column.reorderable === false) {
        cellProps.className = 'unreorderable';
      }

      if (fixLastColumn && isLastLeaf) {
        cellProps.className = NO_RIGHT_BORDR;
      }

      return _react2.default.createElement(
        'div',
        {
          key: key + '-merged-cells-wrap',
          className: prefixCls + '-header-merged-cells-wrap',
          style: { width: width, height: height, left: left }
        },
        _react2.default.createElement(_FlexiGridCell2.default, cellProps),
        _react2.default.createElement(
          'div',
          {
            key: key + '-merged-cells',
            className: prefixCls + '-header-merged-cells',
            style: {
              width: width,
              height: height - rowHeight,
              top: rowHeight
            }
          },
          this.renderHeaderCells({
            prefixCls: prefixCls,
            height: height - rowHeight,
            columns: children,
            fixLastColumn: fixLastColumn
          })
        )
      );
    }
  }, {
    key: 'renderHeaderCells',
    value: function renderHeaderCells() {
      var _this2 = this;

      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var prefixCls = props.prefixCls,
          height = props.height,
          columns = props.columns,
          fixLastColumn = props.fixLastColumn;


      var left = 0;

      return columns.map(function (column) {
        var children = column.children,
            width = column.width,
            title = column.title,
            key = column.key,
            isLastLeaf = column.isLastLeaf;

        var ret = void 0;

        if (children && children.length) {
          ret = _this2.renderHeaderMergedCells(height, left, column);
        } else {
          var cellProps = {
            prefixCls: prefixCls,
            width: width,
            height: height,
            left: left,
            key: key,
            render: title,
            className: {
              unreorderable: column.reorderable === false
            }
          };

          if (fixLastColumn && isLastLeaf) {
            cellProps.className[NO_RIGHT_BORDR] = true;
          }

          ret = _react2.default.createElement(_FlexiGridCell2.default, cellProps);
        }

        left += width;

        return ret;
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          prefixCls = _props3.prefixCls,
          className = _props3.className,
          width = _props3.width,
          height = _props3.height,
          left = _props3.left,
          zIndex = _props3.zIndex,
          isHeader = _props3.isHeader,
          scrollX = _props3.scrollX;

      var wrapStyle = { width: width, height: height, left: left, zIndex: zIndex };
      var innerStyle = { width: width, height: height };

      (0, _utils.translateDOMPosition)(innerStyle, -scrollX, 0, this.initialRender);

      return _react2.default.createElement(
        'div',
        {
          className: prefixCls + '-cells-group-wrap',
          style: wrapStyle
        },
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)(prefixCls + '-cells-group', className),
            style: innerStyle
          },
          isHeader ? this.renderHeaderCells() : this.renderBodyCells()
        )
      );
    }
  }]);
  return FlexiGridCellGroup;
}(_react2.default.Component);

FlexiGridCellGroup.PROPTYPES_DISABLED_FOR_PERFORMANCE = {
  prefixCls: _propTypes2.default.string,
  className: _propTypes4.default.className,
  record: _propTypes4.default.record,
  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  left: _propTypes2.default.number,
  zIndex: _propTypes2.default.number,
  scrollX: _propTypes2.default.number,
  isHeader: _propTypes2.default.bool,
  rowIndex: _propTypes2.default.number,
  rowHeight: _propTypes2.default.number,
  columns: _propTypes4.default.columns,
  leafColumns: _propTypes4.default.columns,
  columnsToRender: _propTypes4.default.columns,
  leafColumnsToRender: _propTypes4.default.columns,
  columnsUpdated: _propTypes2.default.bool,
  columnsToRenderUpdated: _propTypes2.default.bool,
  fixLastColumn: _propTypes2.default.bool
};
exports.default = FlexiGridCellGroup;
module.exports = exports['default'];